#include<stdio.h>
#include<errno.h>

int main(int argc,char *argv[])
{
  FILE *fp;
  
  if (argc != 2){
    fprintf(stderr,"option error\n");
    exit(1);
  }

  if((fp = fopen(argv[1],"r")) == NULL){
    fprintf(stderr,"errno %d\n",errno);
    switch(errno){
    case EACCES:
      fprintf(stderr,"Permission denied\n");
      break;
    default:
      perror("fopen error");
    }

exit(1);
  }

fclose(fp);
exit(0);
}

