#include<stdio.h>
#include<sys/types.h>
#include<unistd.h>
#include<sys/wait.h>

int main(int argc,char *argv[])
{
  pid_t pid;
  int status;

  if((pid = fork()) == (pid_t)-1){
    perror("Cant't fork");
    exit(1);
  }else if (pid == 0){
    printf("[child] fork return vlaue -> %ld\n",pid);
    printf("[child] pid -> %ld\n",getpid());
    sleep(5);
    exit(25);
  }

  printf("[parent] fork return value -> %ld\n",pid);

  if(wait(&status) == -1) {
    perror("wait");
    exit(1);
  }
  
  printf("[parent] pid -> %ld\n",getpid());
  printf("child end status = %d\n", WEXITSTATUS(status));

  exit(0);
}
