#include<stdio.h>
#include<sys/types.h>
#include<unistd.h>
#include<sys/wait.h>

int main(int argc, char *argv[])
{
  pid_t pid;
  int status;
  FILE *fp;
  char buf[BUFSIZ];

  if((fp = fopen("./4.c","r")) == NULL){
    perror("fpoen");
    exit(1);
  }

  if((pid = fork()) == (pid_t)-1){
    perror("Can't fork");
    exit(1);
  }else if (pid == 0){
    while (fgets(buf,BUFSIZ,fp) != NULL)
      printf("[c] %s",buf);
    exit(0);
  }

  if(wait(&status) == -1){
    perror("wait");
    exit(1);
  }

  if (fseek(fp, 0, SEEK_SET) == -1){
    perror("wait");
    exit(1);
  }

  while (fgets(buf,BUFSIZ,fp) != NULL)
    printf("[p] %s",buf);

  exit(0);
}
