#include<stdio.h>
#include<sys/types.h>
#include<unistd.h>
#include<sys/wait.h>

int main(int argc,char *argv[])
{
  pid_t pid;
  int status;

  if ((pid = fork()) == (pid_t)-1){
    perror("Can't fork");
    exit(1);
  }else if (pid == 0){
    if(execlp("ls","ls","-F", (char *)NULL) == -1){
      perror("execlp");
      exit(1);
    }
    exit(0);
  }

  if(wait(&status) == -1){
    perror("wait");
    exit(1);
  }
  exit(0);
}
