#include<stdio.h>
#include<unistd.h>
#include<pthread.h>
#include<thread.h>

#define MAXTHR 5

typedef struct {
  char type;
  int num;
  char str[BUFSIZ];
}thr_arg;

void *dispmsg(void *arg)
{
  thr_arg thrarg;
  int i;

  memcpy(&thrarg, arg, sizeof(thr_arg));
  for(i = 0; i < thrarg.num; i ++){
    printf("[Ttread tye %c](Thread ID %d) %s%d\n",thrarg.type,
	   thr_self(),thrarg.str,i);
    sleep(2);
  }
  return(NULL);
}

int main(int argc, char *argv[])
{
  thread_t thrid[MAXTHR];
  pthread_t pthrid[MAXTHR];
  thr_arg thrarg;
  int i;

  if(argc !=2){
    fprintf(stderr,"usase: %s <Thread Type>\n",argv[0]);
    fprintf(stderr," <Thread Type>s ...Solaris Thread\n");
    fprintf(stderr,"              P ...POSIXThread\n");
    exit(1);
  }

  thrarg.num = 5;
  sprintf(thrarg.str,"Hoge");

  switch(*argv[1]){
  case 's':
    thrarg.type ='s';
    for(i = 0; i < MAXTHR;i++){
      thr_create(NULL,NULL,dispmsg,(void*)&thrarg,0,&thrid[i]);
    }

    for( i =0; i < MAXTHR;i++){
      thr_join(thrid[i],NULL,NULL);
    }
    break;
    break;
  case 'P':
    thrarg.type = 'P';
    for(i - 0; i < MAXTHR; i++){
      pthread_create(&pthrid[i],NULL,dispmsg,(void *)&thrarg);
      }
    for(i = 0; i < MAXTHR; i++){
      pthread_join(pthrid[i],NULL);
    }
    break;
  default:
    break;
  }
  exit();
}







