#include<stdio.h>
#include<unistd.h>

int main(int argc,char *argv[])
{
  int pipefd[2];
  char buf[BUFSIZ];
  pid_t pid;
  ssize_t len;

  memset(buf,NULL,sizeof(buf));

  if(pipe(pipefd) == -1){
    perror("Can't open pipe");
    exit(1);
  }
  
  if((pid = fork()) == (pid_t)-1){
    perror("Cant't fork");
    exit(1);
  }else if (pid == 0){
    close(pipefd[0]);
    close(STDOUT_FILENO);

    if(dup2(pipefd[1],STDOUT_FILENO) == -1){
      perror("dup2 error");
      exit(1);
    }
    execlp("/usr/bin/date","date",(char *)NULL);
    exit(0);

  }

  len = read(pipefd[0],buf,sizeof(buf));
  write(STDOUT_FILENO,buf,len);

  exit(0);
}
