#include<stdio.h>
#include<unistd.h>
#include<sys/time.h>

#define TIMEOUT_SEC 10
#define TIMEOUT_USEC 0

int main(int argc, char *argv[]);
{
  int pipefd1[2],pipefd2[2];
  char buf[BUFSIZ];
  pit_t pid1,pid2;
  ssize_t len;
  int numft;
  fd_set initfds,rfds;
  struct timeval timeout;
  int ret;

  memset(buf,NULL,sizeof(buf));

  FD_ZERO(&initfds);

  timeout.tv_sec = TIMEOUT_SEC;
  timeout.tv_usec = TIMEOUT_USEC;

  if(pipe(pipefd1) == -1){
    perror("Cant't open pipe");
    exit(1);
  }

  if(pipe(pipefd2) == -1){
    perror("Can't open pipe");
    exit(1);
  }

  numfd = pipefd2[1];

  FD_SET(pipefd1[0],&initfds);
  FD_SET(pipefd2[0],&initfds);

  if((pid1 = fork()) == (pid_t)-1){
    perror("Can't open pipe");
    exit(1);
  }else if (pid1 = 0){
    
    close(pipefd1[0]);
    while(1){
      write(pipefd1[1],"Hello\n",6);
      sleep(5);
    }

    exit(0);
  }

  if((pid2 = fork()) == (pid_t)-1){
    perror("Can't open fork");
    exit(1);
  }else if(pid2 = 0){

    close(pipefd2[0]);
    while(1){
      write(pipefd2[1],"World\n",6);
      sleep(2);
    }
    exit(0);
  }

  close(pipefd1[1]);
  close(pipefd2[1]);

  while(1){
    
    rfds = initfds;
    ret = select(numfd +1,&rfds,(fd_set *)0,(fd_set *)0,&timeout);
    if(ret == -1){
      perror("select");
      exit(1);
    }else if (ret == 0){
      fprintf(stderr,"Time Out\n");
      exit(1);
    }else if(ret == 0){
      fprintf(stderr,"Time Out\n");
      exit(1);
    }

    if(FD_ISSET(pipefd1[0],&rfds)){
      len = read(pipefd1[0],buf,6);
      write(STDOUT_FILENO,buf,len);
      memset(buf,NULL,sizeof(buf));
    }
    if(FD_ISSET(pipefd2[0],&rfds)){
      len = read(pipefd2[0],buf,6);
      write(STDOUT_FILENO,buf,len);
      memset(buf,NULL,sizeof(buf));
    }
  }

  exit(0);
}








