#include<stdio.h>
#include<unistd.h>

int main(int argc, char *argv[])
{
  int pipefd1[2],pipefd2[2];
  char buf[BUFSIZ];
  pid_t pid1,pid2;
  ssize_t len;

  memset(buf,NULL,sizeof(buf));

  if(pipe(pipefd1) == -1){
    perror("Can't open pipe");
    exit(1);
  }

  if(pipe(pipefd2) == -1){
    perror("Cant't open pipe");
    exit(1);
  }

  if((pid1 = fork()) == (pid_t)-1){
    perror("Cant't open pipe");
    exit(1);
  }else if (pid1 == 0){
    close(pipefd1[0]);
    while(1){
      write(pipefd1[1],"Hello\n",6);
      sleep(5);
    }
    exit(0);
  }
  
  if((pid2 = fork()) == (pid_t)-1){
    perror("Cant't fort");
    exit(1);
  }else if (pid2 == 0){
    close(pipefd2[0]);
    while(1){
      write(pipefd2[1],"World\n",6);
      sleep(2);
    }
    exit(0);
  }

  close(pipefd1[1]);
  close(pipefd2[1]);

  while(1){
    len = read(pipefd1[0],buf,6);
    write(STDOUT_FILENO,buf,len);
    memset(buf,NULL,sizeof(buf));
    
    len = read(pipefd2[0],buf,6);
    write(STDOUT_FILENO,buf,len);
    memset(buf,NULL,sizeof(buf));
  }

  exit(0);
}

