#include<stdio.h>
#include<stdlib.h>

struct list{
  int data;
  struct list *next;
};

/* $B%j%9%H$N@hF,%G!<%?(B*/
struct list *root;

/*
 *$B%j%9%H$K%G!<%?$r3JG<$9$k4X?t(B
 *
 *$B0z?t#1(B:$BEPO?$9$kCM(B
 *$BLa$jCM(B:$B$J$7(B
 */
void addlist(int indata)
{
  struct list *nlist;
  struct list *plist;
  
  if((nlist = (struct list *)malloc(sizeof(struct list))) == NULL){
    perror("Out of Memory");
    exit(1);
  }
  nlist->data = indata;

  /*$B%j%9%H$N:G8e$^$G0\F0$9$k(B*/
  plist = root;
  while (plist->next !=NULL){
    plist = plist->next;
  }

  /*$B:G=*%j%9%H$N(Bnext$B$NCM$r?75,%j%9%H$N(Bnext$B$K3JG<(B*/
  nlist->next = plist->next;
  /*$B:G=*%j%9%H$N(Bnext$B$NCM$K?75,%j%9%H$N%"%I%l%9$r3JG<(B*/
  plist->next = nlist;
}


int main(int argc,char *argv[])
{

  struct list *nowlist;

  if((root = (struct list *)malloc(sizeof(struct list))) == NULL){
  perror("Out of Memory");
  exit(1);
}

/*$B%j%9%H$N@hF,%G!<%?$r3JG<$9$k(B*/
root->data = 10;
root->next = NULL;

/*$B%j%9%H$K%G!<%?$r3JG<$9$k(B*/
addlist(20);
addlist(30);
addlist(40);

/*$BI=<($r9T$&(B*/
nowlist = root;
while (nowlist != NULL){
  printf("%d\n",nowlist->data);
  nowlist = nowlist->next;
}

exit(0);
}


