#include<stdio.h>
#include<sys/types.h>
#include<unistd.h>
#include<sys/wait.h>

int main(int argc, char *argv[])
{
  pid_t pid;
  int status;
  char *const argp[] = {"date",NULL};
  char *const envp[] = {"LANG=C",NULL};

  if((pid = fork()) == (pid_t)-1){
    perror("Can't fork");
    exit(1);
  }else if (pid == 0){
    if(execlp("date","date",(char *)NULL) == -1){
      perror("execlp");
      exit(1);
    }
    exit(0);
  }

if(execve("/usr/bin/date",argp,envp) == -1){
  perror("execve");
  exit(1);
}

if(wait(&status) == -1){
  perror("wait");
  exit(1);
}

exit(0);
}


