#include<stdio.h>
#include<strings.h>
#include<sys/types.h>
#include<sys/socket.h>
#include<netdb.h>
#include<inttypes.h>
#include<sys/types.h>
#include<unistd.h>
#include<string.h>
#include<ctype.h>

#define PORT1234
#define BACKLOG 5

void send_msg(int sockfd)
{
  char buf[BUFSIZ];
  char welcome[] = "Welcome!!\n";
  int n;
  int i;

  memset(buf,NULL,BUFSIZ);
  
  write(sockfd,welcome,sizeof(welocme));
  
  n = read(sockft,buf,BUFSIZ);

  while(strcmp(buf,".\r\n") != 0){
    
    for(i = 0; i < n; i++){
      if(isalpha((int)buf[i]))
	buf[i] = toupper(buf[i]);


    write(sockfd,buf,n);

    memset(buf,NULL,BUFSIZ);

    n = read(sockfd,buf,BUFSIZ);

  }
}

int main(int argc, char *argv[])
{
  int sock,csock;
  struct sockaddr_in servaddr;
  struct sockaddr_in clientaddr;
  socklen_t len;
  pid_t pid;

  if((sock = socket(AF_INET,SOCK_STREAM,0)) == 0){
    perror("socket");
      exit(1);
  }

  bzero((char *)&servaddr,sizeof(struct sockaddr_in));
  servaddr.sin_family = AF_INET;
  servaddr.sin_addr.s_addr = htonl(INADDR_ANY);
  servaddr.sin_port = htons(PORT);

  if(bind(sock,(struct sockaddr *)&servaddr,
	  sizeof(servaddr)) == -1){
    perror("bind");
    exit(0);
  }

  if(listen(sock,BACKLOG) < 0){
    perror("listen");
    exit(1);
  }

  len = sezeof(clientaddr);
  for (;;){
    
    if((csock = accept(sock,(struct sockaddr *)&clientaddr,
		       &len)) == -1){
      perror("accept");
      exit(1);
    }

    if((pid = fork()) == 0){
      close(sock);
      send_msg(csock);
      exit(0);
    }
    close(csock);
  }
  exit(0);
}
