#include<stdio.h>
#include<unistd.h>

int main(int argc,char *argv[])
{
  int pipefd[2];
  char buf[BUFSIZ];
  pid_t pid;
  ssize_t len;

  memset(buf,NULL,sizeof(buf));

  if(pipe(pipefd) == -1){
    perror("Can't open pipe");
    exit(1);
  }
  
  if((pid = fork()) == (pid_t)-1){
    perror("Cant't fork");
    exit(1);
  }else if (pid == 0){
    close(pipefd[0]);
    write(pipefd[1],"Hello\n",6);

    exit(0);
  }

  close(pipefd[1]);
  len = read(pipefd[0],buf,6);
  write(STDOUT_FILENO,buf,len);

  exit(0);
}
